# -*- coding: utf-8 -*-

"""
ctddocumentation

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""

from ctddocumentation.api_helper import APIHelper
from ctddocumentation.configuration import Server
from ctddocumentation.controllers.base_controller import BaseController
from apimatic_core.request_builder import RequestBuilder
from apimatic_core.response_handler import ResponseHandler
from apimatic_core.types.parameter import Parameter
from ctddocumentation.http.http_method_enum import HttpMethodEnum
from apimatic_core.authentication.multiple.single_auth import Single
from apimatic_core.authentication.multiple.and_auth_group import And
from apimatic_core.authentication.multiple.or_auth_group import Or
from ctddocumentation.models.get_events_response import GetEventsResponse


class EventsController(BaseController):

    """A Controller to access Endpoints in the ctddocumentation API."""
    def __init__(self, config):
        super(EventsController, self).__init__(config)

    def get_events(self,
                   page=None,
                   per_page=None,
                   site_id=None,
                   id__exact='3-1',
                   alert_id__exact='56-1',
                   timestamp__exact=None,
                   last_updated__exact=None,
                   description__contains=None,
                   description__icontains=None,
                   type__exact=None,
                   status__exact=None,
                   sort=None):
        """Does a GET request to /ranger/events.

        Get Events

        Args:
            page (int, optional): TODO: type description here.
            per_page (int, optional): TODO: type description here.
            site_id (int, optional): TODO: type description here.
            id__exact (string, optional): TODO: type description here.
                Example: 3-1
            alert_id__exact (string, optional): TODO: type description here.
                Example: 56-1
            timestamp__exact (string, optional): TODO: type description here.
            last_updated__exact (string, optional): The timestamp when the
                latest change on the Event was made in the EMC.   **Format:**
                YYYY-MM-DD**T**HH:MM:SS (in UTC)  **Example:**
                2022-11-01T16:22:05
            description__contains (string, optional): TODO: type description
                here.
            description__icontains (string, optional): TODO: type description
                here.
            type__exact (int, optional): 0: eNewAsset | 1: eAssetConflict | 2:
                eBaselineDeviation | 3: eThreat | 4: eAssetInformationChange |
                5: eProtocolSpecific  6: eBaselineDown | 8:
                eBaselineVolumeDeviationHigh | 9: eBaselineVolumeDeviationLow
                | 10: eFTPData  11: eBaselineRule | 12: eHighArpActivity | 13:
                eKnownThreatEvent | 14: eFalseMac | 15:
                eSuspiciousFileTransfer  16: ePolicyViolation | 17:
                ePolicyRuleMatch | 18: eHostScan | 19: ePortScan | 20:
                eDenialOfService
            status__exact (StatusExactEnum, optional): TODO: type description
                here.
            sort (Sort6Enum, optional): TODO: type description here.

        Returns:
            GetEventsResponse: Response from the API. Successful Operation

        Raises:
            APIException: When an error occurs while fetching the data from
                the remote API. This exception includes the HTTP Response
                code, an error message, and the HTTP body that was received in
                the request.

        """

        return super().new_api_call_builder.request(
            RequestBuilder().server(Server.DEFAULT)
            .path('/ranger/events')
            .http_method(HttpMethodEnum.GET)
            .query_param(Parameter()
                         .key('page')
                         .value(page))
            .query_param(Parameter()
                         .key('per_page')
                         .value(per_page))
            .query_param(Parameter()
                         .key('site_id')
                         .value(site_id))
            .query_param(Parameter()
                         .key('id__exact')
                         .value(id__exact))
            .query_param(Parameter()
                         .key('alert_id__exact')
                         .value(alert_id__exact))
            .query_param(Parameter()
                         .key('timestamp__exact')
                         .value(timestamp__exact))
            .query_param(Parameter()
                         .key('last_updated__exact')
                         .value(last_updated__exact))
            .query_param(Parameter()
                         .key('description__contains')
                         .value(description__contains))
            .query_param(Parameter()
                         .key('description__icontains')
                         .value(description__icontains))
            .query_param(Parameter()
                         .key('type__exact')
                         .value(type__exact))
            .query_param(Parameter()
                         .key('status__exact')
                         .value(status__exact))
            .query_param(Parameter()
                         .key('sort')
                         .value(sort))
            .header_param(Parameter()
                          .key('accept')
                          .value('application/json'))
            .auth(Single('global'))
        ).response(
            ResponseHandler()
            .deserializer(APIHelper.json_deserialize)
            .deserialize_into(GetEventsResponse.from_dictionary)
        ).execute()
