# -*- coding: utf-8 -*-

"""
ctddocumentation

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""

from ctddocumentation.api_helper import APIHelper
from ctddocumentation.configuration import Server
from ctddocumentation.controllers.base_controller import BaseController
from apimatic_core.request_builder import RequestBuilder
from apimatic_core.response_handler import ResponseHandler
from apimatic_core.types.parameter import Parameter
from ctddocumentation.http.http_method_enum import HttpMethodEnum
from apimatic_core.authentication.multiple.single_auth import Single
from apimatic_core.authentication.multiple.and_auth_group import And
from apimatic_core.authentication.multiple.or_auth_group import Or
from ctddocumentation.models.get_all_sites_response import GetAllSitesResponse


class SitesController(BaseController):

    """A Controller to access Endpoints in the ctddocumentation API."""
    def __init__(self, config):
        super(SitesController, self).__init__(config)

    def get_all_sites(self,
                      rid__exact=None,
                      sort=None,
                      format=None,
                      page=1,
                      per_page=20):
        """Does a GET request to /ranger/sites.

        Get all sites and their information

        Args:
            rid__exact (string, optional): TODO: type description here.
            sort (Sort31Enum, optional): Sort order: add '-' for descending
                order
            format (SiteListSlimEnum, optional): TODO: type description here.
            page (int, optional): TODO: type description here. Example: 1
            per_page (int, optional): TODO: type description here. Example:
                20

        Returns:
            GetAllSitesResponse: Response from the API. Successful Operation

        Raises:
            APIException: When an error occurs while fetching the data from
                the remote API. This exception includes the HTTP Response
                code, an error message, and the HTTP body that was received in
                the request.

        """

        return super().new_api_call_builder.request(
            RequestBuilder().server(Server.DEFAULT)
            .path('/ranger/sites')
            .http_method(HttpMethodEnum.GET)
            .query_param(Parameter()
                         .key('rid__exact')
                         .value(rid__exact))
            .query_param(Parameter()
                         .key('sort')
                         .value(sort))
            .query_param(Parameter()
                         .key('format')
                         .value(format))
            .query_param(Parameter()
                         .key('page')
                         .value(page))
            .query_param(Parameter()
                         .key('per_page')
                         .value(per_page))
            .header_param(Parameter()
                          .key('accept')
                          .value('application/json'))
            .auth(Single('global'))
        ).response(
            ResponseHandler()
            .deserializer(APIHelper.json_deserialize)
            .deserialize_into(GetAllSitesResponse.from_dictionary)
        ).execute()
