# -*- coding: utf-8 -*-

"""
ctddocumentation

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""

from ctddocumentation.api_helper import APIHelper
from ctddocumentation.configuration import Server
from ctddocumentation.controllers.base_controller import BaseController
from apimatic_core.request_builder import RequestBuilder
from apimatic_core.response_handler import ResponseHandler
from apimatic_core.types.parameter import Parameter
from ctddocumentation.http.http_method_enum import HttpMethodEnum
from apimatic_core.authentication.multiple.single_auth import Single
from apimatic_core.authentication.multiple.and_auth_group import And
from apimatic_core.authentication.multiple.or_auth_group import Or
from ctddocumentation.models.get_queries_ids_and_assigned_task_response import GetQueriesIdsAndAssignedTaskResponse


class TasksQueriesController(BaseController):

    """A Controller to access Endpoints in the ctddocumentation API."""
    def __init__(self, config):
        super(TasksQueriesController, self).__init__(config)

    def get_queries_ids_and_assigned_task(self,
                                          site_id,
                                          scan_rid):
        """Does a GET request to /ranger/task_query_configurations.

        List all queries and their ids, and which queries are assigned to the
        task

        Args:
            site_id (int): TODO: type description here.
            scan_rid (string): TODO: type description here.

        Returns:
            GetQueriesIdsAndAssignedTaskResponse: Response from the API.
                Successful Operation

        Raises:
            APIException: When an error occurs while fetching the data from
                the remote API. This exception includes the HTTP Response
                code, an error message, and the HTTP body that was received in
                the request.

        """

        return super().new_api_call_builder.request(
            RequestBuilder().server(Server.DEFAULT)
            .path('/ranger/task_query_configurations')
            .http_method(HttpMethodEnum.GET)
            .query_param(Parameter()
                         .key('site_id')
                         .value(site_id))
            .query_param(Parameter()
                         .key('scan_rid')
                         .value(scan_rid))
            .header_param(Parameter()
                          .key('accept')
                          .value('application/json'))
            .auth(Single('global'))
        ).response(
            ResponseHandler()
            .deserializer(APIHelper.json_deserialize)
            .deserialize_into(GetQueriesIdsAndAssignedTaskResponse.from_dictionary)
        ).execute()
